Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent
Class DelayQueue<E extends Delayed>

    java.lang.Object
      java.util.AbstractCollection<E>
          java.util.AbstractQueue<E>
              java.util.concurrent.DelayQueue<E>

Type Parameters:
  `E` - the type of elements held in this collection

All Implemented Interfaces:
  Iterable<E>, Collection<E>, BlockingQueue<E>, Queue<E>

    public class DelayQueue<E extends Delayed>

extends AbstractQueue<E>
implements BlockingQueue<E>

An unbounded blocking queue of `Delayed` elements, in which an element can only be taken when its delay has expired. The head of the queue is that `Delayed` element whose delay expired furthest in the past. If no delay has expired there is no head and `poll` will return `null`. Expiration occurs when an element's `getDelay(TimeUnit.NANOSECONDS)` method returns a value less than or equal to zero. This queue does not permit `null` elements.

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces.

This class is a member of the Java Collections Framework.

Since:
  1.5

Constructor Summary
`DelayQueue()` Creates a new `DelayQueue` that is initially empty.
`DelayQueue(Collection<? extends E> c)` Creates a `DelayQueue` initially containing the elements of the given collection of `Delayed` instances.

Method Summary
`boolean` | `add(E o)` Adds the specified element to this queue.
`void` | `clear()` Atomically removes all of the elements from this delay queue.
`int` | `drainTo(Collection<? super E> c)` Removes all available elements from this queue and adds them into the given collection.
`int` | `drainTo(Collection<? super E> c, int maxElements)` Removes at most the given number of available elements from this queue and adds them into the given collection.
`Iterator<E>` | `iterator()` Returns an iterator over the elements in this queue.
`boolean` | `offer(E o)` Inserts the specified element into this delay queue.
`boolean` | `offer(E o, long timeout, TimeUnit unit)` Inserts the specified element into this delay queue.
`E` | `peek()` Retrieves, but does not remove, the head of this queue, returning `null` if this queue has no elements with an unexpired delay.
`E` | `poll()` Retrieves and removes the head of this queue, or `null` if this queue has no elements with an unexpired delay.
`E` | `poll(long timeout, TimeUnit unit)` Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time if no elements with an unexpired delay are present on this queue.
`void` | `put(E o)` Adds the specified element to this delay queue.
`int` | `remainingCapacity()` Always returns `Integer.MAX_VALUE` because a `DelayQueue` is not capacity constrained.
`boolean` | `remove(Object o)` Removes a single instance of the specified element from this queue, if it is present.
`int` | `size()` Returns the number of elements in this collection.
`E` | `take()` Retrieves and removes the head of this queue, waiting if no elements with an unexpired delay are present on this queue.
`Object[]` | `toArray()` Returns an array containing all of the elements in this collection.
`
`<T> T[]`
` | `toArray(T[] array)` Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.

Methods inherited from class java.util.AbstractQueue
`addAll, element, remove`

Methods inherited from class java.util.AbstractCollection
`contains, containsAll, isEmpty, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Queue
`element, remove`

Methods inherited from interface java.util.Collection
`addAll, contains, containsAll, equals, hashCode, isEmpty, removeAll, retainAll`

Constructor Detail

### DelayQueue

    public DelayQueue()

  Creates a new `DelayQueue` that is initially empty.

### DelayQueue

    public DelayQueue(Collection<? extends E> c)

  Creates a `DelayQueue` initially containing the elements of the given collection of `Delayed` instances.

  Parameters:
    `c` - the collection
  Throws:
    `NullPointerException` - if `c` or any element within it is `null`

Method Detail

### offer

    public boolean offer(E o)

  Inserts the specified element into this delay queue.

  Specified by:
    `offer` in interface `BlockingQueue<E extends Delayed>`
  Specified by:
    `offer` in interface `Queue<E extends Delayed>`
  Parameters:
    `o` - the element to add
  Returns:
    `true`
  Throws:
    `NullPointerException` - if the specified element is `null`.

### put

    public void put(E o)

  Adds the specified element to this delay queue. As the queue is unbounded this method will never block.

  Specified by:
    `put` in interface `BlockingQueue<E extends Delayed>`
  Parameters:
    `o` - the element to add
  Throws:
    `NullPointerException` - if the specified element is `null`.

### offer

    public boolean offer(E o,
                         long timeout,
                         TimeUnit unit)

  Inserts the specified element into this delay queue. As the queue is unbounded this method will never block.

  Specified by:
    `offer` in interface `BlockingQueue<E extends Delayed>`
  Parameters:
    `o` - the element to add
    `timeout` - This parameter is ignored as the method never blocks
    `unit` - This parameter is ignored as the method never blocks
  Returns:
    `true`
  Throws:
    `NullPointerException` - if the specified element is `null`.

### add

    public boolean add(E o)

  Adds the specified element to this queue.

  Specified by:
    `add` in interface `Collection<E extends Delayed>`
  Specified by:
    `add` in interface `BlockingQueue<E extends Delayed>`
  Overrides:
    `add` in class `AbstractQueue<E extends Delayed>`
  Parameters:
    `o` - the element to add
  Returns:
    `true` (as per the general contract of `Collection.add`).
  Throws:
    `NullPointerException` - if the specified element is `null`.

### take

    public E take()
                           throws InterruptedException

  Retrieves and removes the head of this queue, waiting if no elements with an unexpired delay are present on this queue.

  Specified by:
    `take` in interface `BlockingQueue<E extends Delayed>`
  Returns:
    the head of this queue
  Throws:
    `InterruptedException` - if interrupted while waiting.

### poll

    public E poll(long timeout,
                  TimeUnit unit)
                           throws InterruptedException

  Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time if no elements with an unexpired delay are present on this queue.

  Specified by:
    `poll` in interface `BlockingQueue<E extends Delayed>`
  Parameters:
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    the head of this queue, or `null` if the specified waiting time elapses before an element with an unexpired delay is present.
  Throws:
    `InterruptedException` - if interrupted while waiting.

### poll

    public E poll()

  Retrieves and removes the head of this queue, or `null` if this queue has no elements with an unexpired delay.

  Specified by:
    `poll` in interface `Queue<E extends Delayed>`
  Returns:
    the head of this queue, or `null` if this queue has no elements with an unexpired delay.

### peek

    public E peek()

  Retrieves, but does not remove, the head of this queue, returning `null` if this queue has no elements with an unexpired delay.

  Specified by:
    `peek` in interface `Queue<E extends Delayed>`
  Returns:
    the head of this queue, or `null` if this queue has no elements with an unexpired delay.

### size

    public int size()

  Description copied from class: `AbstractCollection`
  Returns the number of elements in this collection. If the collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Collection<E extends Delayed>`
  Specified by:
    `size` in class `AbstractCollection<E extends Delayed>`
  Returns:
    the number of elements in this collection.

### drainTo

    public int drainTo(Collection<? super E> c)

  Description copied from interface: `BlockingQueue`
  Removes all available elements from this queue and adds them into the given collection. This operation may be more efficient than repeatedly polling this queue. A failure encountered while attempting to `add` elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue<E extends Delayed>`
  Parameters:
    `c` - the collection to transfer elements into
  Returns:
    the number of elements transferred.

### drainTo

    public int drainTo(Collection<? super E> c,
                       int maxElements)

  Description copied from interface: `BlockingQueue`
  Removes at most the given number of available elements from this queue and adds them into the given collection. A failure encountered while attempting to `add` elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue<E extends Delayed>`
  Parameters:
    `c` - the collection to transfer elements into
    `maxElements` - the maximum number of elements to transfer
  Returns:
    the number of elements transferred.

### clear

    public void clear()

  Atomically removes all of the elements from this delay queue. The queue will be empty after this call returns.

  Specified by:
    `clear` in interface `Collection<E extends Delayed>`
  Overrides:
    `clear` in class `AbstractQueue<E extends Delayed>`

### remainingCapacity

    public int remainingCapacity()

  Always returns `Integer.MAX_VALUE` because a `DelayQueue` is not capacity constrained.

  Specified by:
    `remainingCapacity` in interface `BlockingQueue<E extends Delayed>`
  Returns:
    `Integer.MAX_VALUE`

### toArray

    public Object[] toArray()

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection. If the collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order. The returned array will be "safe" in that no references to it are maintained by the collection. (In other words, this method must allocate a new array even if the collection is backed by an Array). The caller is thus free to modify the returned array.

  This implementation allocates the array to be returned, and iterates over the elements in the collection, storing each object reference in the next consecutive element of the array, starting with element 0.

  Specified by:
    `toArray` in interface `Collection<E extends Delayed>`
  Overrides:
    `toArray` in class `AbstractCollection<E extends Delayed>`
  Returns:
    an array containing all of the elements in this collection.

### toArray

    public <T> T[] toArray(T[] array)

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array. If the collection fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this collection.

  If the collection fits in the specified array with room to spare (i.e., the array has more elements than the collection), the element in the array immediately following the end of the collection is set to `null`. This is useful in determining the length of the collection only if the caller knows that the collection does not contain any `null` elements.)

  If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  This implementation checks if the array is large enough to contain the collection; if not, it allocates a new array of the correct size and type (using reflection). Then, it iterates over the collection, storing each object reference in the next consecutive element of the array, starting with element 0. If the array is larger than the collection, a `null` is stored in the first location after the end of the collection.

  Specified by:
    `toArray` in interface `Collection<E extends Delayed>`
  Overrides:
    `toArray` in class `AbstractCollection<E extends Delayed>`
  Parameters:
    `array` - the array into which the elements of the collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of the collection.

### remove

    public boolean remove(Object o)

  Removes a single instance of the specified element from this queue, if it is present.

  Specified by:
    `remove` in interface `Collection<E extends Delayed>`
  Overrides:
    `remove` in class `AbstractCollection<E extends Delayed>`
  Parameters:
    `o` - element to be removed from this collection, if present.
  Returns:
    `true` if the collection contained the specified element.

### iterator

    public Iterator<E> iterator()

  Returns an iterator over the elements in this queue. The iterator does not return the elements in any particular order. The returned iterator is a thread-safe "fast-fail" iterator that will throw `ConcurrentModificationException` upon detected interference.

  Specified by:
    `iterator` in interface `Iterable<E extends Delayed>`
  Specified by:
    `iterator` in interface `Collection<E extends Delayed>`
  Specified by:
    `iterator` in class `AbstractCollection<E extends Delayed>`
  Returns:
    an iterator over the elements in this queue.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.